
int bufferSize=1024;
int filterSize = 1024; 
boolean filtering = false;

// Eingabe Real- and Imaginärteil
float[] ir,im;
// Ausgabe Real and Imaginärteil
float[] or,om,pw;
float[] rr,rm;

int function = 1;   // verwendete Funktion 

//////////////////////////////////////////////////

void generateFunctionAndFFT(int selector, float modifier1, float modifier2) {
  
  switch (selector) {

  case 1 :   // einfacher Sinus
    for (int i=0; i<bufferSize; i++) {
      ir[i] = 100*modifier2 *sin(i/(100*modifier1+1));
      im[i] = 0;
    }
    break;

 case 2 : // eine Sprungfunktion
    for (int i=0; i<bufferSize; i++) {
      if (sin(i/(100*modifier1+1))>0) ir[i] = 100*modifier2;
                                     else ir[i] = -100*modifier2;
      im[i] = 0;
    }
    break;

  case 3 : // weisses Rauschen erzeugt Rauschen im Frequenzraum
    for (int i=0; i<bufferSize; i++) {
      ir[i] = 100*modifier2 * random(-1, 1);
      im[i] = 0;
    }
    break;

  case 4 : // sin(x^^2) erzeugt ganz unterschiedliche Frequenzen
    for (int i=0; i<bufferSize; i++) {
      ir[i] = 100*modifier2 *sin(sq(i/(500*modifier1+1)));
      im[i] = 0;
    }
    break;
   }
  
 for (int i=0; i<bufferSize; i++) {
      or[i] = ir[i];
      om[i] = im[i];
 }      
 
 fft_1D(1,bufferSize,or,om);  
  
 if (filtering) { 
     for (int i=0; i<bufferSize; i++) {
        rr[i] = ((i<filterSize/2) || (i>bufferSize-filterSize/2)) ? or[i] : 0;
        rm[i] = ((i<filterSize/2) || (i>bufferSize-filterSize/2)) ? om[i] : 0;
     } 
     fft_1D(-1,bufferSize,rr,rm);  
  }
}

//////////////////////////////////////////////////

void setup()
{
 // size(512, 512, JAVA2D);
  size(1024, 1024, JAVA2D);
  
  ir = new float[bufferSize];
  im = new float[bufferSize];
  or = new float[bufferSize];
  om = new float[bufferSize];
  rr = new float[bufferSize];
  rm = new float[bufferSize];
  pw = new float[bufferSize];

  generateFunctionAndFFT(1, 0.5, 0.5);
}

//////////////////////////////////////////////////

void draw()
{
  background(255);
  noFill();
  strokeWeight(1);  

 // berechne das Powerspektrum der FT
 for (int i=0; i<bufferSize; i++) 
      pw[i] = sqrt(sq((or[i])+sq(om[i]))); 


  stroke(255,0,0);
  for (int i = 0; i < filterSize/2; i++) {
    line( 2*i, height-10, 2*i, height -10 - 5*pow(pw[i],2f/3));
    line( 2*i+1, height-10, 2*i+1, height - 10 - 5*pow(pw[bufferSize-i-1],2f/3));
  }
  if (filtering) {
    stroke(0,0,255);
    for (int i=1; i<bufferSize; i++)
      line(i-1, height/2-rr[i-1], i, height/2-rr[i]);
  }
  stroke(0);
  strokeWeight(2);
  for (int i=1; i<bufferSize; i++)
    line(i-1, height/2-ir[i-1], i, height/2-ir[i]);

}

//////////////////////////////////////////////////
// modify parameters of the funcion by moving the mouse
//////////////////////////////////////////////////

void mouseMoved() {

  generateFunctionAndFFT(function, map(mouseX, 0, width, 0, 1), 
    map(mouseY, 0, height-mouseY, 0, 1));
}

//////////////////////////////////////////////////
// the number keys are used to switch between functions
//////////////////////////////////////////////////

void keyPressed() {
  switch (key) {
  case '1' : function = 1; break;
  case '2' : function = 2; break;
  case '3' : function = 3; break;
  case '4' : function = 4; break;
  case 'f' : filtering = !filtering; break; 
  case '+' : filterSize = min(512,filterSize+5); break;
  case '-' : filterSize = max(1,filterSize-5); break;
  case 's' : save("test.png"); break;
  }
  generateFunctionAndFFT(function, map(mouseX, 0, width, 0, 1), 
    map(mouseY, 0, height-mouseY, 0, 1));   
}       